\section{Sources used for threats and vulnerabilities}\label{sec:sources}

After establishing what automated checks were available to the public, the next step was to determine the missing ones and needed to be created in order to provide a well-rounded Burp plugin and useful to any kind of developer. This information is far from trivial and more importantly the sources used which determines what the most common vulnerabilities and threats are even more important.

We decided to use two main sources for this matter, the first a well-known document redacted to illustrate the best current practice to ensure a safe use of OAuth, the second a recap on a meeting on threats and vulnerabilities on federation protocols (OpenID Connect\cite{openid} and SAML 2.0\cite{rfc7522rfcsaml2})
 
\subsection{OAuth 2.0 Security Best Current Practice\cite{oauthcurrentpractice13}}
This document describes the best current security practices for OAuth 2.0 and it groups them in 13 sections:
\begin{enumerate}
	\item{Insufficient Redirect URI validation}
	\item{Credential Leakage via Referrer Headers}
	\item{Attacks through Browser History}
	\item{Mix-up Attacks}
	\item{Authorization code Injection}
	\item{Access Token Injection}
	\item{Cross Site Request Forgery}
	\item{Access Token Leakage at the Resource Server}
	\item{Open Redirection}
	\item{307 Redirection}
	\item{TLS Terminating Reverse Proxies}
	\item{Refresh Token Protection}
	\item{Client Impersonating Resource Owner}
\end{enumerate}
This RFC explains why some practices should be used to ensure less vulnerabilities, including the use of some extensions already explained in the thesis.

Given the fact that the document taken in consideration is a draft, it is valid for a maximum period of six months and it may be updated or replaced after that, so it is suggested to look for an updated version at the time of reading of this document. As of our case, during the implementation of the plugin a new draft\cite{oauthcurrentpractice14} has been published with updated content, more specifically on new refresh token security concerns and a 14th category, Clickjacking.
\newpage
\subsection{OWASP Helsinki Chapter Meeting \#30 October 11, 2016\cite{helsinki_owasp}}
Owasp\cite{owasp} is a community-driven website about web application security. It provides articles, tools documentation and technologies to the public. Two renowned products/services are OWASP Top 10\cite{owasptop10}, a selection of the most important and influential vulnerabilities, and Zed Attack Proxy (ZAP)\cite{owaspzap}, a tool for automated security testing.

One topic discussed by this community is SSO frameworks and this document summarizes a meeting on security concerns on well known and used protocols, such as OAuth 2.0, OpenID Connect, and Saml 2.0. This piece of writing describes established vulnerabilities in the above protocols using both theoretical knowledge describing why some vulnerabilities are presents and  real life cases of wrong implementations in recognized sites or applications.
\newpage